import java.util.*;

public class Check
{
	public static final int MAXN = 100;
	public static final int MAXM = 4500;


	public static void printError(int line, String msg)
	{
		System.out.println("ERROR Line " + line + ": " + msg);
		System.exit(-1);
	}

	public static boolean repeated(LangPair [] a, int n)
	{
		for(int i=0; i<n; i++) {
			if (a[i].l1.equals(a[n].l1) && a[i].l2.equals(a[n].l2))
				return true;
			if (a[i].l1.equals(a[n].l2) && a[i].l2.equals(a[n].l1))
				return true;
		}
		return false;
	}

	public static boolean repeated(String [] a, int n)
	{
		for(int i=0; i<n; i++)
			if (a[i].equals(a[n]))
				return true;
		return false;
	}

	public static int find(String [] a, int n, String s)
	{
		for(int i=0; i<n; i++)
			if (a[i].equals(s))
				return i;
		return 0;
	}

	public static void main(String [] args)
	{
		Scanner in = new Scanner(System.in);
		int n, m, nLines = 1;
		String line;
		String [] names = new String[MAXN+1];

		names[0] = "English";
		n = in.nextInt();
		if (n < 1 || n > MAXN)
			printError(1, "n value out of range: " + n);
		m = in.nextInt();
		if (m < 1 || m > MAXM)
			printError(1, "m value out of range: " + m);
		line = in.nextLine();
		line = in.nextLine();
		nLines++;
		StringTokenizer st = new StringTokenizer(line);
		if (st.countTokens() != n) 
			printError(nLines, "incorrect number of languages");
		for(int i=0; i<n; i++) {
			names[i] = st.nextToken();
			if (repeated(names, i))
				printError(nLines, "repeated language name: " + names[i]);
		}
		LangPair [] pairs = new LangPair[m];
		for(int i=0; i<m; i++) {
			line = in.nextLine();
			nLines++;
			st = new StringTokenizer(line);
			if (st.countTokens() != 3)
				printError(nLines, "incorrect number of tokens on line");
			String n1 = st.nextToken();
			int index1 = find(names, n, n1);
			if (index1 == -1)
				printError(nLines, "illegal language name: " + n1);
			String n2 = st.nextToken();
			int index2 = find(names, n, n2);
			if (index2 == -1)
				printError(nLines, "illegal language name: " + n2);
			int cost = Integer.parseInt(st.nextToken());
			if (cost < 1)
				printError(nLines, "illegal cost: " + cost);
			pairs[i] = new LangPair(n1, n2);
			if (repeated(pairs, i))
				printError(nLines, "repeated pair of languages: " + n1 + "," + n2);
		}
		if (in.hasNext())
			printError(nLines+1, "extraneous data at end of file");
System.exit(42);
	}
}

class LangPair
{
	public String l1;
	public String l2;

	public LangPair(String n1, String n2) {
		l1 = n1;
		l2 = n2;
	}
}
